=== debian/changelog ===
cg3 (1.3.1-2build3) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:32:22 +0100

cg3 (1.3.1-2build2) focal; urgency=medium

  * No-change rebuild against libicu65

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Feb 2020 16:34:50 +0000

cg3 (1.3.1-2build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:30:47 +0000

cg3 (1.3.1-2) unstable; urgency=low

  * Source only upload.

 -- Kartik Mistry <kartik@debian.org>  Wed, 04 Dec 2019 17:54:25 +0530

cg3 (1.3.1-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Update to latest upstream
    + Added Python module
    + Added cg3-dev metapackage
  * Updated Standards-Version to 4.4.1
  * Bumped dh to 12

  [ Kartik Mistry ]
  * Added debian/gitlab-ci.yml

 -- Kartik Mistry <kartik@debian.org>  Sun, 13 Oct 2019 18:07:47 +0530
