## cg3 1.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,7 +39,7 @@
 endif()
 
 if(MSVC)
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /permissive- /W4 /MP")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /Zc:__cplusplus /permissive- /W4 /MP")
 	set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /O2")
 	set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")
 	set(CMAKE_C_FLAGS ${CMAKE_CXX_FLAGS})
@@ -51,7 +51,7 @@
 	include(CheckCXXCompilerFlag)
 
 	foreach(flag "-Wno-unused-result" "-flto")
-		string(REGEX REPLACE "[^A-Za-z0-9]" "-" _flag ${flag})
+		string(REGEX REPLACE "[^A-Za-z0-9]" "" _flag ${flag})
 		CHECK_CXX_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})
 			set(_FLAGS_COMMON "${_FLAGS_COMMON} ${flag}")
@@ -70,7 +70,7 @@
 
 	# Enable latest possible C standard
 	foreach(flag "-std=c2x" "-std=c11" "-std=c1x" "-std=c99")
-		string(REGEX REPLACE "[^a-z0-9]" "-" _flag ${flag})
+		string(REGEX REPLACE "[^a-z0-9]" "" _flag ${flag})
 		CHECK_C_COMPILER_FLAG(${flag} COMPILER_SUPPORTS_${_flag})
 		if(COMPILER_SUPPORTS_${_flag})
 			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flag}")
