=== src/CMakeLists.txt ===
--- 
+++ 
@@ -119,7 +119,7 @@
 	${POPEN_PLUS_CPP}
 	${LIBCG3_HEADERS}
 	)
-if(MSVC)
+if(WIN32)
 	set(LIBCG3_SOURCES
 		"${CMAKE_SOURCE_DIR}/include/win32/getopt.cpp"
 		"${CMAKE_SOURCE_DIR}/include/win32/getopt.h"
@@ -165,6 +165,7 @@
 	PlaintextApplicator.cpp
 	PlaintextApplicator.hpp
 	options_conv.hpp
+	options_parser.hpp
 	)
 cg3_link(cg-conv)
 target_link_libraries(cg-conv ${LINKLIB})
@@ -173,7 +174,11 @@
 cg3_link(cg-mwesplit)
 target_link_libraries(cg-mwesplit ${LINKLIB})
 
-add_executable(vislcg3 main.cpp options.hpp)
+add_executable(vislcg3
+	main.cpp
+	options.hpp
+	options_parser.hpp
+	)
 cg3_link(vislcg3)
 target_link_libraries(vislcg3 ${LINKLIB})
