=== debian/changelog ===
cg3 (1.3.2-1build2) jammy; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Feb 2022 05:54:22 +0100

cg3 (1.3.2-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:08:26 +0000

cg3 (1.3.2-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Update to latest upstream
  * debian/control:
    + Updated Standards-Version to 4.5.1

  [ Kartik Mistry ]
  * Updated debian/watch file.
  * Removed unused debian/libcg3-1.lintian-overrides.

 -- Kartik Mistry <kartik@debian.org>  Tue, 15 Dec 2020 13:22:22 +0530
