=== debian/control ===
--- 
+++ 
@@ -1,22 +1,22 @@
 Source: cg3
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@alioth-lists.debian.net>
 Uploaders: Tino Didriksen <tino@didriksen.cc>,
            Kartik Mistry <kartik@debian.org>
 Build-Depends: cmake,
-               debhelper (>= 12),
+               debhelper-compat (= 13),
                dh-python,
                libboost-dev,
                libicu-dev,
                python3-dev,
                python3-setuptools,
                swig
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Homepage: https://visl.sdu.dk/cg3.html
 Vcs-Git: https://salsa.debian.org/science-team/cg3.git
 Vcs-Browser: https://salsa.debian.org/science-team/cg3
+Rules-Requires-Root: no
 
 Package: cg3
 Architecture: any
