=== src/CMakeLists.txt ===
--- 
+++ 
@@ -86,6 +86,7 @@
 	sorted_vector.hpp
 	stdafx.hpp
 	streambuf.hpp
+	string_view.hpp
 	uextras.hpp
 	version.hpp
 	)
