=== debian/changelog ===
cg3 (1.3.6-1) unstable; urgency=low

  [ Tino Didriksen ]
  * Update to latest upstream.
  * debian/control:
    + Updated Standards-Version to 4.6.0

  [ Kartik Mistry ]
  * debian/control:
    + Removed XB-Python-Version field.
    + python3-cg3: Updated extended description.

 -- Kartik Mistry <kartik@debian.org>  Mon, 14 Mar 2022 10:00:06 +0530
