=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                python3-dev,
                python3-setuptools,
                swig
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://visl.sdu.dk/cg3.html
 Vcs-Git: https://salsa.debian.org/science-team/cg3.git
 Vcs-Browser: https://salsa.debian.org/science-team/cg3
@@ -83,10 +83,12 @@
 Architecture: any
 Section: python
 Provides: ${python3:Provides}
-XB-Python-Version: ${python3:Versions}
 Depends: libcg3-1 (= ${binary:Version}),
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
 Description: Wrapper for CG-3
- Wrapper to use CG-3 from Python
+ Constraint Grammar compiler and applicator for the 3rd edition of CG
+ that is developed and maintained by VISL SDU and GrammarSoft ApS.
+ .
+ This package provides wrapper to use CG-3 from Python.
