=== debian/watch ===
version=4
https://github.com/GrammarSoft/cg3/releases \
 .*/@PACKAGE@-(\d[\d.]*)\.tar\.bz2 debian uupdate
