=== src/CMakeLists.txt ===
--- 
+++ 
@@ -86,7 +86,6 @@
 	sorted_vector.hpp
 	stdafx.hpp
 	streambuf.hpp
-	string_view.hpp
 	uextras.hpp
 	version.hpp
 	)
@@ -124,6 +123,8 @@
 	set(LIBCG3_SOURCES
 		"${CMAKE_SOURCE_DIR}/include/win32/getopt.cpp"
 		"${CMAKE_SOURCE_DIR}/include/win32/getopt.h"
+		"${CMAKE_SOURCE_DIR}/include/win32/wordexp.cpp"
+		"${CMAKE_SOURCE_DIR}/include/win32/wordexp.h"
 		${LIBCG3_SOURCES}
 		)
 endif()
