=== debian/changelog ===
cg3 (1.3.9-1) unstable; urgency=medium

  * Update to latest upstream
  * debian/
    + control: Update S-V to 4.6.1
    + rules: Enable link-time optimization
    + watch: Use Github API instead

 -- Tino Didriksen <tino@didriksen.cc>  Fri, 07 Oct 2022 19:38:36 +0200
