=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                python3-dev,
                python3-setuptools,
                swig
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://visl.sdu.dk/cg3.html
 Vcs-Git: https://salsa.debian.org/science-team/cg3.git
 Vcs-Browser: https://salsa.debian.org/science-team/cg3
