=== debian/watch ===
version=4
opts="searchmode=plain" \
  https://api.github.com/repos/grammarsoft/@PACKAGE@/releases \
  https://github.com/grammarsoft/@PACKAGE@/releases/download/v(?:\d[\d.]*)/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
