## cg3 1.4.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,6 @@
 set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 set(CMAKE_MACOSX_RPATH ON)
-set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
 
 file(READ src/version.hpp _cg3_VERSION_FILE)
 string(REGEX REPLACE ".*CG3_VERSION_MAJOR = ([0-9]+).*" "\\1" _cg3_VERSION_MAJOR ${_cg3_VERSION_FILE})
@@ -30,13 +29,7 @@
 include(GNUInstallDirs)
 
 option(BUILD_SHARED_LIBS "Set to OFF to use static library" ON)
-option(USE_TCMALLOC "Set to OFF to disable linking against TCMalloc" ON)
 option(ENABLE_PYTHON_BINDINGS "Set to ON to build the Python wrapper" OFF)
-
-if(APPLE)
-	message(STATUS "Disabling TCMalloc for OS X")
-	set(USE_TCMALLOC OFF)
-endif()
 
 if(MSVC)
 	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /utf-8 /std:c++latest /Zc:__cplusplus /permissive- /W4 /MP")
@@ -113,13 +106,29 @@
 	add_definitions(-DBIG_ENDIAN)
 endif()
 
+CHECK_INCLUDE_FILE_CXX(filesystem HAS_FS)
+if(HAS_FS)
+	add_definitions(-DHAS_FS)
+endif()
+
+# std::filesystem is in a separate library until g++ 9
+if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9)
+	set(STDFS_LIB stdc++fs)
+endif()
+
 if(WIN32)
 	add_definitions(-DUNICODE -D_UNICODE -D_SECURE_SCL=0 -D_ITERATOR_DEBUG_LEVEL=0 -D_CRT_SECURE_NO_DEPRECATE -DWIN32_LEAN_AND_MEAN -DVC_EXTRALEAN -DNOMINMAX -D_SILENCE_CXX20_CISO646_REMOVED_WARNING)
-	include_directories("include/win32")
+	include_directories("include/getopt" "include/wordexp")
 else()
-	add_definitions(-D_POSIX_C_SOURCE=200112)
+	add_definitions(-D_POSIX_C_SOURCE=200112 -DBOOST_NO_CXX98_FUNCTION_BASE=1)
 	set(POPEN_PLUS_CPP "../include/posix/popen_plus.cpp" "../include/posix/popen_plus.hpp")
 	include_directories("include/posix")
+endif()
+if(EMSCRIPTEN)
+	include_directories("include/wordexp")
+	set(CMAKE_EXECUTABLE_SUFFIX ".html")
+	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g3 -gsource-map")
+	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g3 -gsource-map")
 endif()
 
 add_definitions(-DUNISTR_FROM_CHAR_EXPLICIT=explicit -DUNISTR_FROM_STRING_EXPLICIT=explicit)
