=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,49 +8,52 @@
 find_path(Boost_LOCAL NAMES boost/config.hpp PATHS "../include" NO_DEFAULT_PATH)
 if(Boost_LOCAL)
 	set(BOOST_ROOT "../include")
-	find_package(Boost 1.53.0)
+	find_package(Boost 1.62.0)
 endif()
 if(NOT Boost_FOUND)
 	unset(BOOST_ROOT)
 	message(STATUS "Did not find Boost locally; trying globally...")
 	message(STATUS "If this doesn't work, run ./get-boost.sh and try again.")
-	find_package(Boost 1.53.0 REQUIRED)
+	find_package(Boost 1.62.0 REQUIRED)
 endif()
 include_directories(${Boost_INCLUDE_DIRS})
 link_directories(${Boost_LIBRARY_DIRS})
 
 # ICU
-find_package(ICU REQUIRED)
+find_package(ICU 59.0 COMPONENTS i18n io uc data REQUIRED)
 if(ICU_FOUND)
-	if(ICU_VERSION VERSION_LESS "50.0")
-		message(FATAL_ERROR "ICU is too old - ${ICU_VERSION} was found, but CG-3 requires 50.0 or newer")
-	endif()
 	include_directories(${ICU_INCLUDE_DIRS})
 	message(STATUS "Found ICU version ${ICU_VERSION}")
 endif()
-
-if(NOT CMAKE_BUILD_TYPE STREQUAL Debug AND USE_TCMALLOC)
-	find_library(GOOGLE_TCMALLOC_LIB tcmalloc)
-	if(GOOGLE_TCMALLOC_LIB)
-		message(STATUS "Found tcmalloc: ${GOOGLE_TCMALLOC_LIB}")
-		set(GOOGLE_TCMALLOC_ENABLED 1)
-	else()
-		message(STATUS "Can't find tcmalloc - skipping")
+link_directories(${ICU_LIBRARY_DIRS})
+
+if(VCPKG_TOOLCHAIN)
+	find_path(SQLITE3_INCLUDE_DIRS sqlite3.h REQUIRED)
+	find_library(SQLITE3_LIBRARIES sqlite3 REQUIRED)
+else()
+	find_package(PkgConfig REQUIRED)
+	pkg_search_module(SQLITE3 REQUIRED sqlite3)
+endif()
+include_directories(${SQLITE3_INCLUDE_DIRS})
+link_directories(${SQLITE3_LIBRARY_DIRS})
+
+macro(cg3_link target)
+	if(EMSCRIPTEN)
+		target_link_options(${target} PRIVATE
+			-sEXPORTED_RUNTIME_METHODS=ccall,cwrap
+			# Generated with: pcregrep -o 'cg3_\S+\(' src/cg3.h | perl -wpne "s/\(//g; s/^/'_/; s/\n/',/;"
+			-sEXPORTED_FUNCTIONS=['_cg3_init','_cg3_init','_cg3_cleanup','_cg3_cleanup','_cg3_grammar_load','_cg3_grammar_load_buffer','_cg3_grammar_free','_cg3_applicator_create','_cg3_applicator_setflags','_cg3_applicator_setoption','_cg3_applicator_setoption','_cg3_applicator_setoption','_cg3_applicator_free','_cg3_run_grammar_on_text','_cg3_run_grammar_on_text_fns','_cg3_mwesplitapplicator_create','_cg3_sentence_new','_cg3_sentence_copy','_cg3_sentence_runrules','_cg3_sentence_addcohort','_cg3_sentence_numcohorts','_cg3_sentence_getcohort','_cg3_sentence_free','_cg3_cohort_create','_cg3_cohort_setwordform','_cg3_cohort_getwordform','_cg3_cohort_getid','_cg3_cohort_setdependency','_cg3_cohort_getdependency','_cg3_cohort_addreading','_cg3_cohort_numreadings','_cg3_cohort_getreading','_cg3_cohort_free','_cg3_reading_create','_cg3_reading_addtag','_cg3_reading_numtags','_cg3_reading_gettag','_cg3_reading_numtraces','_cg3_reading_gettrace','_cg3_reading_free','_cg3_subreading_create','_cg3_reading_setsubreading','_cg3_reading_numsubreadings','_cg3_reading_getsubreading','_cg3_subreading_free','_cg3_tag_create_u','_cg3_tag_create_u8','_cg3_tag_create_u16','_cg3_tag_create_u32','_cg3_tag_create_w','_cg3_tag_gettext_u','_cg3_tag_gettext_u8','_cg3_tag_gettext_u16','_cg3_tag_gettext_u32','_cg3_tag_gettext_w','_cg3_cohort_numdelreadings','_cg3_cohort_getdelreading','_cg3_reading_gettrace_ruletype']
+			-sASSERTIONS=1
+			)
 	endif()
-endif()
-
-macro(cg3_link target)
-	if(GOOGLE_TCMALLOC_ENABLED)
-		target_link_libraries(${target} ${GOOGLE_TCMALLOC_LIB})
-	endif()
-
-	if(WIN32)
-		target_link_libraries(${target} "wsock32.lib")
-	endif()
-
-	target_link_libraries(${target} ${CMAKE_THREAD_LIBS_INIT})
-	target_link_libraries(${target} ${Boost_LIBRARIES})
-	target_link_libraries(${target} ${ICU_LIBRARIES} ${ICU_IO_LIBRARIES} ${ICU_I18N_LIBRARIES})
+
+	target_link_libraries(${target}
+		${CMAKE_THREAD_LIBS_INIT}
+		${STDFS_LIB}
+		${Boost_LIBRARIES}
+		${ICU_LIBRARIES}
+		${SQLITE3_LIBRARIES}
+		)
 endmacro()
 
 set(LIBCG3_HEADERS
@@ -65,6 +68,7 @@
 	Relabeller.hpp
 	MweSplitApplicator.hpp
 	IGrammarParser.hpp
+	Profiler.hpp
 	Reading.hpp
 	Rule.hpp
 	Set.hpp
@@ -81,6 +85,7 @@
 	inlines.hpp
 	interval_vector.hpp
 	parser_helpers.hpp
+	pool.hpp
 	process.hpp
 	scoped_stack.hpp
 	sorted_vector.hpp
@@ -99,6 +104,7 @@
 	ContextualTest.cpp
 	Grammar.cpp
 	GrammarApplicator.cpp
+	GrammarApplicator_context.cpp
 	GrammarApplicator_matchSet.cpp
 	GrammarApplicator_reflow.cpp
 	GrammarApplicator_runContextualTest.cpp
@@ -107,6 +113,7 @@
 	GrammarWriter.cpp
 	Relabeller.cpp
 	MweSplitApplicator.cpp
+	Profiler.cpp
 	Reading.cpp
 	Rule.cpp
 	Set.cpp
@@ -119,12 +126,17 @@
 	${POPEN_PLUS_CPP}
 	${LIBCG3_HEADERS}
 	)
+if(WIN32 OR EMSCRIPTEN)
+	set(LIBCG3_SOURCES
+		"${CMAKE_SOURCE_DIR}/include/wordexp/wordexp.cpp"
+		"${CMAKE_SOURCE_DIR}/include/wordexp/wordexp.h"
+		${LIBCG3_SOURCES}
+		)
+endif()
 if(WIN32)
 	set(LIBCG3_SOURCES
-		"${CMAKE_SOURCE_DIR}/include/win32/getopt.cpp"
-		"${CMAKE_SOURCE_DIR}/include/win32/getopt.h"
-		"${CMAKE_SOURCE_DIR}/include/win32/wordexp.cpp"
-		"${CMAKE_SOURCE_DIR}/include/win32/wordexp.h"
+		"${CMAKE_SOURCE_DIR}/include/getopt/getopt.cpp"
+		"${CMAKE_SOURCE_DIR}/include/getopt/getopt.h"
 		${LIBCG3_SOURCES}
 		)
 endif()
@@ -134,12 +146,12 @@
 cg3_link(cg3)
 set(LINKLIB cg3)
 
-add_executable(cg-comp cg_comp.cpp)
+add_executable(cg-comp cg-comp.cpp)
 cg3_link(cg-comp)
 target_link_libraries(cg-comp ${LINKLIB})
 
 add_executable(cg-proc
-	cg_proc.cpp
+	cg-proc.cpp
 	ApertiumApplicator.cpp
 	ApertiumApplicator.hpp
 	MatxinApplicator.cpp
@@ -153,7 +165,7 @@
 target_link_libraries(cg-relabel ${LINKLIB})
 
 add_executable(cg-conv
-	cg_conv.cpp
+	cg-conv.cpp
 	ApertiumApplicator.cpp
 	ApertiumApplicator.hpp
 	MatxinApplicator.cpp
@@ -176,6 +188,14 @@
 cg3_link(cg-mwesplit)
 target_link_libraries(cg-mwesplit ${LINKLIB})
 
+add_executable(cg-annotate cg-annotate.cpp)
+cg3_link(cg-annotate)
+target_link_libraries(cg-annotate ${LINKLIB})
+
+add_executable(cg-merge-annotations cg-merge-annotations.cpp)
+cg3_link(cg-merge-annotations)
+target_link_libraries(cg-merge-annotations ${LINKLIB})
+
 add_executable(vislcg3
 	main.cpp
 	options.hpp
@@ -188,7 +208,7 @@
 target_link_libraries(test_libcg3 ${LINKLIB})
 
 if(APPLE)
-	foreach(t cg-conv cg-comp cg-proc cg-relabel cg-mwesplit vislcg3)
+	foreach(t cg-conv cg-comp cg-proc cg-relabel cg-mwesplit cg-annotate cg-merge-annotations vislcg3)
 		set("_file_${t}" $<TARGET_FILE:${t}>)
 		add_custom_command(
 			TARGET ${t}
@@ -207,4 +227,4 @@
 
 install(TARGETS cg3 ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
 install(FILES cg3.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
-install(TARGETS cg-comp cg-proc cg-relabel cg-mwesplit cg-conv vislcg3 RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+install(TARGETS cg-comp cg-proc cg-relabel cg-mwesplit cg-conv cg-annotate cg-merge-annotations vislcg3 RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
