=== debian/changelog ===
cg3 (1.4.6-1build2) noble; urgency=medium

  * No-change rebuild with Python 3.12 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 19 Jan 2024 19:05:56 +0000

cg3 (1.4.6-1build1) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:05:15 +0100

cg3 (1.4.6-1) unstable; urgency=medium

  * Update to latest upstream
  * Handle locating Python with CMake >= 3.12.0 (Closes: #1042249)

 -- Tino Didriksen <tino@didriksen.cc>  Fri, 04 Aug 2023 12:52:03 +0200
