=== debian/control ===
--- 
+++ 
@@ -9,6 +9,8 @@
                dh-python,
                libboost-dev,
                libicu-dev,
+               libsqlite3-dev,
+               pkg-config,
                python3-dev,
                python3-setuptools,
                swig
