=== debian/changelog ===
cg3 (1.5.0-1) unstable; urgency=medium

  * Update to latest upstream
  * Upstream URLs changed from visl.sdu.dk to edu.visl.dk
  * debian/control:
    + Updated Standards-Version to 4.7.2

 -- Tino Didriksen <tino@didriksen.cc>  Tue, 11 Mar 2025 16:26:02 +0100
