=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 export DH_OPTIONS
 export LC_ALL=C.UTF-8
 
-export "DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto"
+export "DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=+lto reproducible=+fixfilepath"
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 
@@ -20,6 +20,3 @@
 	find $(CURDIR) -type f -name '*.pyc' -exec rm -f '{}' \;
 	find $(CURDIR) -type f -name '*.pyo' -exec rm -f '{}' \;
 	find $(CURDIR) -type f -name '*.la' -exec rm -f '{}' \;
-
-override_dh_missing:
-	dh_missing --fail-missing
